module Y
  module Translate
    class Error < StandardError
      ERROR_CODES = {
        default: 'Неизвестная ошибка запроса',
        401 => 'Неправильный API-ключ',
        402 => 'API-ключ заблокирован',
        404 => 'Превышено суточное ограничение на объем переведенного текста',
        413 => 'Превышен максимально допустимый размер текста',
        422 => 'Текст не может быть переведен',
        501 => 'Заданное направление перевода не поддерживается'
      }.freeze

      attr_reader :code

      def initialize(code = :default)
        @code = code
        msg = ERROR_CODES[code]
        super(msg)
      end
    end
  end
end
